Attribute VB_Name = "modDownload"
Option Explicit
'when the Rednload.dll is not licensed it will display a nagging screen when
'any other functions are called. It will display this screen only once after it loaded to memory.
'returns 1 when licensed
Public Declare Function CheckAuthorization Lib "rednload.dll" (ByVal OrderId As String, sPassword As String) As Long

'asynchronous download
'the return value is a reference id for the thread, zero based
'using this id you can distinguish among multiple downloads
'   sURL is the URL to the file to download
'   sFile is the fully qualified path to the file to create or replace
'   sUID is the UserId for secured HTTPS access
'   sPWD is the password for secured HTTPS access
'   lpProcAddressErr is a function pointer to a callback function handling error messages
'   lpProcAddressProg is a function pointer to a callback function handling progress display
'   lpProcAddressDone is a function pointer to a callback function notifying about completion

'when calling from a threadsafe language (like VB 5.0)
Public Declare Function HTTPDownloadAsync Lib "rednload.dll" (ByVal sURL As String, _
                                                    ByVal sFile As String, _
                                                    ByVal sUID As String, _
                                                    ByVal sPwd As String, _
                                                    ByVal lpProcAddressErr As Long, _
                                                    ByVal lpProcAddressProg As Long, _
                                                    ByVal lpProcAddressDone As Long) As Long

'when calling from a not threadsafe language (like VB 6.0)
Public Declare Function HTTPDownloadAsync1 Lib "rednload.dll" (ByVal sURL As String, _
                                                    ByVal sFile As String, _
                                                    ByVal sUID As String, _
                                                    ByVal sPwd As String, _
                                                    ByVal hwndErr As Long, _
                                                    ByVal hwndProg As Long, _
                                                    ByVal hwndDone As Long) As Long
                                                    
'when we do not want a file, only a string content
Public Declare Function WEBResponse Lib "rednload.dll" (ByVal sURL As String, _
                                                    ByVal sUID As String, _
                                                    ByVal sPwd As String, _
                                                    ByVal hwndErr As Long, _
                                                    ByVal hwndProg As Long, _
                                                    ByVal hwndDone As Long, _
                                                    ByVal bCallback As Long) As Long

'retrieving string values in callback functions from a pointer and the length of the string
Public Declare Function GetString Lib "rednload.dll" (ByVal strPointer As Long, ByVal strLen As Long) As String
Public Declare Function CancelJobs Lib "rednload.dll" (ByVal nd As Long) As Long

'getting size and date information of the remote file w/o downloading it
'the return value is the length of the file
'the sDate parameter will return the file date in UTC, you can convert it as
'remDate = Format$(Trim$(Replace(Mid$(remDate, 6), "GMT", "")), "mm/dd/yyyy hh:nn:ss")
Public Declare Function HTTPRemoteFileInfo Lib "rednload.dll" (ByVal sURL As String, _
                                                    sDate As String) As Long
                                                    
'synchronous download
'   sURL is the URL to the file to download
'   sFile is the fully qualified path to the file to create or replace
'   sUID is the UserId for secured HTTPS access
'   sPWD is the password for secured HTTPS access
'the return valu is zero on success or an error code as follows:
'   24  - the TCP reply timed out
'   101 - no network/Internet connection
'   102 - TCP connection could not be established
'   106 - the source file is missing or empty
'   anything else is an error code, most likely due to file locking
Public Declare Function HTTPDownload Lib "rednload.dll" (ByVal sURL As String, _
                                                    ByVal sFile As String, _
                                                    ByVal sUID As String, _
                                                    ByVal sPwd As String) As Long
                                                
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal cBytes&)

Public cDnPtr As Long
Public Type DownloadedBytes
    nd  As Long
    doneBytes As Long
End Type
Public ArrdoneBytes() As DownloadedBytes
'CALLBACK functions for asynchronous download
Public Function REDnload_Error(ByVal nd As Long, ByVal ptrMessage As Long, ByVal lenMessage As Long) As Long
    Dim sErrorMsg As String
    sErrorMsg = GetString(ptrMessage, lenMessage)
    ResolvePointer(cDnPtr).Fire_DownloadError nd, sErrorMsg
End Function
Public Function REDnload_ErrorMsg(ByVal nd As Long, sErrorMsg As String) As Long
    ResolvePointer(cDnPtr).Fire_DownloadError nd, sErrorMsg
End Function

Public Function REDnload_Done(ByVal nd As Long) As Long
    ResolvePointer(cDnPtr).Fire_Done nd
End Function
Public Function REDnload_WEBResponseCallback(ByVal nd As Long, ByVal ptrData As Long, ByVal lenData As Long) As Long
    Dim sData As String
    sData = GetString(ptrData, lenData)
    ResolvePointer(cDnPtr).Fire_WEBResponse nd, sData
End Function

Public Function REDnload_Progress(ByVal nd As Long, ByVal maxBytes As Long, ByVal doneBytes As Long, cancel As Long) As Long
    Dim ndProgress As Long
    If maxBytes > 0 Then
        ndProgress = CLng(doneBytes / maxBytes * 100)
        ResolvePointer(cDnPtr).Fire_DownloadProgress nd, ndProgress, cancel
    End If
End Function
Public Function REDnload_WEBResponse(ByVal nd As Long, ByVal sData As String) As Long
    ResolvePointer(cDnPtr).Fire_WEBResponse nd, sData
End Function
Public Function REDnload_TotalDownloadedBytes(ByVal nd As Long, ByVal doneBytes As Long) As Long
    Dim i As Long
    Dim bFound As Boolean
    Dim lBuffer As Long
    For i = 1 To UBound(ArrdoneBytes)
        If ArrdoneBytes(i).nd = nd Then
            ArrdoneBytes(i).doneBytes = doneBytes
            bFound = True
        End If
    Next
    If Not bFound Then
        ReDim Preserve ArrdoneBytes(UBound(ArrdoneBytes) + 1)
        ArrdoneBytes(UBound(ArrdoneBytes)).nd = nd
        ArrdoneBytes(UBound(ArrdoneBytes)).doneBytes = doneBytes
    End If
    'sum the totals
    For i = 1 To UBound(ArrdoneBytes)
        lBuffer = lBuffer + ArrdoneBytes(i).doneBytes
    Next
    ResolvePointer(cDnPtr).Fire_TotalDownloadBytes lBuffer
End Function
Private Function ResolvePointer(ByVal lpObj&) As clsDownloads
    Dim oDn As clsDownloads
    CopyMemory oDn, lpObj, 4&
    Set ResolvePointer = oDn
    CopyMemory oDn, 0&, 4&
End Function
